VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "winamp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetWindowText Lib "user32" _
                         Alias "GetWindowTextA" _
                        (ByVal hwnd As Long, _
                         ByVal lpString As String, _
                         ByVal cch As Long) As Long
Dim mProp_hWnd As Long
'All the Declarations
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageCDS Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As COPYDATASTRUCT) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const WM_USER = &H400
Private Const WM_WA_IPC = WM_USER
Private Const WM_COPYDATA = &H4A
Private Const WM_COMMAND = &H111
Private Const IPC_GETOUTPUTTIME = 105

' SendMessage Constants
' '''''''''''''''''''''

' Error Constants
' '''''''''''''''
Private Const ErrSource = "Winamp Class"
Private Const Err01 = "Winamp is not running"

' Properties
' ''''''''''
Private mProp_hWnd As Long

Private Type COPYDATASTRUCT
        dwData As Long
        cbData As Long
        lpData As String
End Type

Private Sub Class_Initialize()
   mProp_hWnd = FindWindow("Winamp v1.x", vbNullString)
   If mProp_hWnd = 0 Then
      RaiseError 1, Err01
   End If
End Sub

Private Sub RaiseError(ByVal Number As Long, ByVal description As String, Optional ByVal Source As String = ErrSource)
   On Error Resume Next
   Err.Raise vbObjectError + Number, Source, description
End Sub

Public Property Get hwnd() As Long
   hwnd = mProp_hWnd
End Property

Public Function TrackPrev() As Long
   TrackPrev = SendMessage(mProp_hWnd, WM_COMMAND, 40044, 0&)
End Function

Public Function TrackNext() As Long
   TrackNext = SendMessage(mProp_hWnd, WM_COMMAND, 40048, 0&)
End Function

Public Function TrackPlay() As Long
   TrackPlay = SendMessage(mProp_hWnd, WM_COMMAND, 40045, 0&)
End Function

Public Function TrackPause() As Long
   TrackPause = SendMessage(mProp_hWnd, WM_COMMAND, 40046, 0&)
End Function

Public Function TrackStop() As Long
   TrackStop = SendMessage(mProp_hWnd, WM_COMMAND, 40047, 0&)
End Function

Public Function TrackFadeout() As Long
   TrackFadeout = SendMessage(mProp_hWnd, WM_COMMAND, 40147, 0&)
End Function

Public Function TrackStopAfter() As Long
   TrackStopAfter = SendMessage(mProp_hWnd, WM_COMMAND, 40157, 0&)
End Function

Public Function TrackFForward() As Long
   TrackFForward = SendMessage(mProp_hWnd, WM_COMMAND, 40148, 0&)
End Function

Public Function TrackFRewind() As Long
   TrackFRewind = SendMessage(mProp_hWnd, WM_COMMAND, 40144, 0&)
End Function

Public Function TrackOpenFile() As Long
   TrackOpenFile = SendMessage(mProp_hWnd, WM_COMMAND, 40029, 0&)
End Function

Public Function TrackOpenURL() As Long
   TrackOpenURL = SendMessage(mProp_hWnd, WM_COMMAND, 40155, 0&)
End Function

Public Function TrackInfo() As Long
   TrackInfo = SendMessage(mProp_hWnd, WM_COMMAND, 40188, 0&)
End Function

Public Function ListStart() As Long
   ListStart = SendMessage(mProp_hWnd, WM_COMMAND, 40154, 0&)
End Function

Public Function ListEnd() As Long
   ListEnd = SendMessage(mProp_hWnd, WM_COMMAND, 40158, 0&)
End Function

Public Function VisDispElapsed() As Long
   VisDispElapsed = SendMessage(mProp_hWnd, WM_COMMAND, 40037, 0&)
End Function

Public Function VisDispRemaining() As Long
   VisDispRemaining = SendMessage(mProp_hWnd, WM_COMMAND, 40038, 0&)
End Function

' This Function shows no effect
' '''''''''''''''''''''''''''''
' Public Function VisOptions() As Long
'    VisOptions = SendMessage(mProp_hWnd, WM_COMMAND, 40190, 0&)
' End Function

Public Function VisPlugInOptions() As Long
   VisPlugInOptions = SendMessage(mProp_hWnd, WM_COMMAND, 40191, 0&)
End Function

Public Function VisPlugInExec() As Long
   VisPlugInExec = SendMessage(mProp_hWnd, WM_COMMAND, 40192, 0&)
End Function

Public Function ToggleScrPreferences() As Long
   ToggleScrPreferences = SendMessage(mProp_hWnd, WM_COMMAND, 40012, 0&)
End Function

Public Function ToggleScrAbout() As Long
   ToggleScrAbout = SendMessage(mProp_hWnd, WM_COMMAND, 40041, 0&)
End Function

Public Function ToggleAutoscroll() As Long
   ToggleAutoscroll = SendMessage(mProp_hWnd, WM_COMMAND, 40189, 0&)
End Function

Public Function ToggleAlwaysOnTop() As Long
   ToggleAlwaysOnTop = SendMessage(mProp_hWnd, WM_COMMAND, 40019, 0&)
End Function

Public Function ToggleWindowshadeMain() As Long
   ToggleWindowshadeMain = SendMessage(mProp_hWnd, WM_COMMAND, 40064, 0&)
End Function

Public Function ToggleWindowshadeList() As Long
   ToggleWindowshadeList = SendMessage(mProp_hWnd, WM_COMMAND, 40266, 0&)
End Function

Public Function ToggleDoublesize() As Long
   ToggleDoublesize = SendMessage(mProp_hWnd, WM_COMMAND, 40165, 0&)
End Function

Public Function ToggleEq() As Long
   ToggleEq = SendMessage(mProp_hWnd, WM_COMMAND, 40036, 0&)
End Function

Public Function ToggleList() As Long
   ToggleList = SendMessage(mProp_hWnd, WM_COMMAND, 40040, 0&)
End Function

Public Function ToggleMain() As Long
   ToggleMain = SendMessage(mProp_hWnd, WM_COMMAND, 40258, 0&)
End Function

Public Function ToggleBrowser() As Long
   ToggleBrowser = SendMessage(mProp_hWnd, WM_COMMAND, 40298, 0&)
End Function

Public Function ToggleEasyMove() As Long
   ToggleEasyMove = SendMessage(mProp_hWnd, WM_COMMAND, 40186, 0&)
End Function

Public Function ToggleRepeat() As Long
   ToggleRepeat = SendMessage(mProp_hWnd, WM_COMMAND, 40022, 0&)
End Function

Public Function ToggleShuffle() As Long
   ToggleShuffle = SendMessage(mProp_hWnd, WM_COMMAND, 40023, 0&)
End Function

Public Function VolRaise() As Long
   VolRaise = SendMessage(mProp_hWnd, WM_COMMAND, 40058, 0&)
End Function

Public Function VolLower() As Long
   VolLower = SendMessage(mProp_hWnd, WM_COMMAND, 40059, 0&)
End Function

Public Function MiscJumpToTime() As Long
   MiscJumpToTime = SendMessage(mProp_hWnd, WM_COMMAND, 40193, 0&)
End Function

Public Function MiscJumpToFile() As Long
   MiscJumpToFile = SendMessage(mProp_hWnd, WM_COMMAND, 40194, 0&)
End Function

Public Function MiscSkinSelector() As Long
   MiscSkinSelector = SendMessage(mProp_hWnd, WM_COMMAND, 40219, 0&)
End Function

Public Function MiscSkinReload() As Long
   MiscSkinReload = SendMessage(mProp_hWnd, WM_COMMAND, 40291, 0&)
End Function

Public Function MiscClose() As Long
   MiscClose = SendMessage(mProp_hWnd, WM_COMMAND, 40001, 0&)
End Function

Public Function GetWinampTitle() As String
   Dim strTitle As String
   Dim N As Long
   
   strTitle = Space(2048)
   GetWindowText mProp_hWnd, strTitle, 2048
   Do
      N = N + 1
   Loop Until Asc(Mid$(strTitle, N, 1)) = 0
   strTitle = left$(strTitle, N - 1)
   Dim blag() As String
   blag = Split(strTitle, " ", 2)
   On Error GoTo shkjshkd

   GetWinampTitle = blag(1)
   GoTo theend
shkjshkd:
   GetWinampTitle = "None"
   Exit Function
theend:
End Function


Public Function GetCurrentSongPosition() As Double
'Finds the current song position in milliseconds
    GetCurrentSongPosition = SendMessage(mProp_hWnd, WM_COMMAND, 0, IPC_GETOUTPUTTIME)
End Function

Public Function GetSongLength() As Long
'Finds the song length in Seconds
    GetSongLength = SendMessage(mProp_hWnd, WM_COMMAND, 1, IPC_GETOUTPUTTIME)
End Function
